#ifdef AUXMALLOC  /* enabled by this flag */

#ifndef __AUX_MALLOC__
#define __AUX_MALLOC__

extern int __aux_line__;
extern char *__aux_file__;

extern void aux_malloc_enable(char*,int);
extern void aux_malloc_disable(char*,int);
extern void aux_malloc_verbose(char*,int);
extern void aux_malloc_silent(char*,int);
extern void aux_malloc_memusage(char*,int);
extern void aux_malloc_bgndiff(char*,int);
extern void aux_malloc_enddiff(char*,int);
extern void *aux_calloc(size_t,size_t);
extern char *aux_strdup(const char*);
extern void *aux_malloc(size_t);
extern void *aux_realloc(void*,size_t);
extern void aux_free(void*);

#define malloc (__aux_file__=__FILE__,__aux_line__=__LINE__,aux_malloc)
#define calloc (__aux_file__=__FILE__,__aux_line__=__LINE__,aux_calloc)
#define realloc (__aux_file__=__FILE__,__aux_line__=__LINE__,aux_realloc)
#define free (__aux_file__=__FILE__,__aux_line__=__LINE__,aux_free)
#ifdef strdup
   #undef strdup
#endif
#define strdup (__aux_file__=__FILE__,__aux_line__=__LINE__,aux_strdup)

#define AUX_MALLOC_ENABLE  aux_malloc_enable(__FILE__,__LINE__);
#define AUX_MALLOC_DISABLE aux_malloc_disable(__FILE__,__LINE__);
#define AUX_MALLOC_VERBOSE aux_malloc_verbose(__FILE__,__LINE__);
#define AUX_MALLOC_SILENT  aux_malloc_silent(__FILE__,__LINE__);
#define AUX_MALLOC_MEMUSAGE aux_malloc_memusage(__FILE__,__LINE__);
#define AUX_MALLOC_BGNDIFF  aux_malloc_bgndiff(__FILE__,__LINE__);
#define AUX_MALLOC_ENDDIFF  aux_malloc_enddiff(__FILE__,__LINE__);

#endif /* __AUX_MALLOC__ */

#else /* AUXMALLOC */

#   define ENABLE_AUX_MALLOC  
#   define DISABLE_AUX_MALLOC 
#   define AUX_MALLOC_ENABLE  
#   define AUX_MALLOC_DISABLE
#   define AUX_MALLOC_VERBOSE
#   define AUX_MALLOC_SILENT
#   define AUX_MALLOC_MEMUSAGE 
#   define AUX_MALLOC_BGNDIFF 
#   define AUX_MALLOC_ENDDIFF

#endif /* AUXMALLOC */
