#ifndef __DATA_SET_H
#define __DATA_SET_H

#include <stdio.h>

class data_pairs{
private:
    int   iAllocated;           /* nr of allocated elements of ppfData */
    int   iBytes;               /* bytesize per data el */
    int   iFirst;               /* index of first data el */
    float **ppfData;            /* ptr to start of data array */
    int   **ppiComp;            // ptr to component information
    int   *piNumComp;           // number of non-zero components per data entry
    int   iSparse;              // TRUE if data is sparse
    
public:
    int iNumItems;                /* nr of data elements held */
    int iDimInp;                  /* input dimension */
    int iDimOut;                  /* output dimension */
    data_pairs(int,int,int);
    virtual ~data_pairs(void);
    virtual int eprintf(FILE*,const char*,...);  /* for diagnostics */
    void clear(void);
    int add_item(float*,float*);
    int ins_item(int,float*,float*);
    int del_item(int);
    int set_item(int,float*,float*);
    int get_item(int,float*,float*);
    float *ref_item(int);
    float **for_items(float**, int*);

    int   isSparse()   { return iSparse; }
    int   *for_sparse_items(int *piCurrent, float *pfInp, float *pfOut);
    void  add_sparse_item(int iPos, float *pfInp, float *pfOut);
    float cos_angle(int iWhich, float *pfVec);
    void  adapt_sparse(float *pfVec, int iWhich, float fEps);
};

#endif

