#ifndef __NST10_H__
#define __NST10_H__

#define NST_DYNBYTE  "C"
#define NST_DYNINT   "I"
#define NST_DYNFLOAT "F"

typedef struct nst_dynarray_{
   int   iNumDim;   /* nr of dimensions (default = 1) */
   int   iByteSize; /* total byte size */
   int   *piDim;    /* iNumDim dimensions */
   union {
      void          *pAdr;     
      float         *pfAdr;    /* first value */
      NstInt_t      *piAdr;    /* first value */
      unsigned char *pcAdr;    /* first value */
   } v;
} nst_dynarray_t;

#ifdef __NST_TYPES_H
  extern int nst_dim_of_dynarray_p(pin*);
  extern char nst_is_dynarray_p(pin*,char);
  extern void nst_set_dynarray_p(pin*,pin*);
  extern void nst_set_dynarray_p_from_scalar(pin*,pin*);
  extern nst_dynarray_t 
     *nst_copy_dynarray_t(nst_dynarray_t*,nst_dynarray_t*);
  extern int nst_dim_of_dyn_inp(unitptr u, int iField, int iPin);
  extern int nst_dim_of_dyn_out(unitptr u, int iField, int iPin);
  extern void *nst_resize(unitptr  u,int iField,int iPin,int iDim);       
  extern void *nst_reshape(unitptr u,int iField,int iPin,int iNumDim,int *piDim);
  extern void *nst_reassign(unitptr u, int iField, int iPin, int iDim, void *pData);
  extern void nst_map_dynarray_p(pin*,int,void*,void*);
  extern void nst_unmap_dynarray_p(pin*,void*);

  extern void *nst_resize_dynarray_p(pin*,int);
  extern void update_dynarray_rdrs(pin *p);

# define pfNstDynInp(U,F,P) (((nst_dynarray_t*)((U)->in[F]->p[P]->s))->v.pfAdr)
# define pfNstDynOut(U,F,P) (((nst_dynarray_t*)((U)->out[F]->p[P]->s))->v.pfAdr)
# define piNstDynInp(U,F,P) (((nst_dynarray_t*)((U)->in[F]->p[P]->s))->v.piAdr)
# define piNstDynOut(U,F,P) (((nst_dynarray_t*)((U)->out[F]->p[P]->s))->v.piAdr)
# define pcNstDynInp(U,F,P) (((nst_dynarray_t*)((U)->in[F]->p[P]->s))->v.pcAdr)
# define pcNstDynOut(U,F,P) (((nst_dynarray_t*)((U)->out[F]->p[P]->s))->v.pcAdr)
# define pvNstDynInp(U,F,P) (((nst_dynarray_t*)((U)->in[F]->p[P]->s))->v.pAdr)
# define pvNstDynOut(U,F,P) (((nst_dynarray_t*)((U)->out[F]->p[P]->s))->v.pAdr)
# define pvNstDynAdr(P)     (((nst_dynarray_t*)((P)->s))->v.pAdr)

#else
  extern int nst_dim_of_dynarray_p(void*);
  extern char nst_is_dynarray_p(void*,char);
  extern void nst_set_dynarray_p(void*,void*);
  extern void nst_set_dynarray_p_from_scalar(void*,void*);
  extern nst_dynarray_t 
     *nst_copy_dynarray_t(nst_dynarray_t*,nst_dynarray_t*);
#endif

#endif

