/*****************************************************************************
 *
 * nst2.h  -  NST kernel layer 2: Fields
 *
 * Copyright Helge Ritter, 1992 1993
 *
 * $Source: /vol/ni/src/cvsroot/nst5/nstsrc/nst2.h,v $
 *
 * $Log: nst2.h,v $
 * Revision 1.4  1997/04/29 15:11:10  helge
 * changes necessary with introduction of user-specified data types.
 *
 * Revision 1.3  1997/04/02 14:07:01  helge
 * most man pages now in source code; some corrections;
 * for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:48:30  jan
 * Dependency cleanup.
 *
 *
 *****************************************************************************/

#ifndef __NST2_H
#define __NST2_H
#include "nst_types.h"
#define host_of_p(P) \
      ((field*)(((P)->t & NST_MULTITYPEPIN) ? (P)->ext->host \
                                  : (P)->ext)) 

#define rect_of_f(f) (f->r)

#define equal_rectangles(a,b) \
((a)->xll == (b)->xll && (a)->yll == (b)->yll &&\
 (a)->w == (b)->w && (a)->h == (b)->h)

#define dim_of_f(F) ((F)->npins)

extern  field *mk_f(int,int,void*);
extern  field *mk_typed_f(void*,int,char);
extern  char *fmt_of_f(field*);
extern  char *nst_borrowed_fmt_of_f(field*);
extern  void rm_f(field*);
extern  int dim_of(field*);
extern  int npins_of(field*);
extern  int id_of_p(pin*);
extern  int is_packed(field*);
extern  int is_out_f(field*);
extern  int is_out_p(pin*);
extern  field* f_of_p(pin*);
extern  int eq_f(field*, field*);
extern  int alloc_f(field*);
extern  int not_restrictable(field*);
extern  pin* source_of_p(pin *p);
extern  int is_legal_scalar_to_vector(field*,field*);
extern  int is_legal_sv(field*,pin*);
extern  int has_only_scalar_pins(field*);
extern int nst_compatible_ff(field*,field*);
extern int nst_is_connected_f(field *pF);
extern int nst_compatible_ff_0(field *pF1, field *pF2);
extern int source_is_free_input(pin *p);

#endif
