/*****************************************************************************
 *
 * nst8.h  -  NST kernel layer 8: Types
 *
 * Copyright Helge Ritter, 1992
 *
 * $Source: /vol/ni/src/cvsroot/nst5/nstsrc/nst8.h,v $
 *
 * $Log: nst8.h,v $
 * Revision 1.4  2005/07/12 07:49:33  rhaschke
 * added new copy_values_of_f_0: which allows adaption of current type of
 * SPECIAL_T/VOID_T pins (needed for use_methods)
 *
 * Revision 1.3  1997/04/02 14:07:39  helge
 * most man pages now in source code; some corrections;
 * for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:48:48  jan
 * Dependency cleanup.
 *
 *
 *****************************************************************************/

#ifndef __NST8_H
#define __NST8_H
#include "nst_types.h"

extern pin *install_type(pin*, char);
extern pin *uninstall_type(pin*, char);
extern void do_type_conversions(pin*, char*);
extern int copy_values_of_p(pin *pFrom, pin *pTo);
extern int copy_values_of_f_0(field *pFrom, field *pTo, int bUpdateSpecialType);
extern int copy_values_of_f(field *pFrom, field *pTo);
extern void *get_adr_for_type(int iOffset, pin *p, pin*q);
extern int set_up_conversions(pin *pSrc, pin *pDest);
extern void *get_adr_for_ctype(int iOffset, pin *p, char cType);
extern int uses_output_conversion(unitptr);
extern int uses_input_conversion(unitptr);
extern int change_t_of_p(pin *p, char cNewType);
extern void nst_disable_type_conversions(void);
extern void nst_enable_type_conversions(void);
extern int uses_conversion(pin *p);
extern void pp_to_ff_for_vs_pair(pin *q, pin *p);
extern int unjoin_vs_pair(pin *q, pin *p);
extern void check(int iLine);

#endif

