/*****************************************************************************
 *
 * nst_array.h  -  header for array unit
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source: /vol/ni/src/cvsroot/nst5/nstsrc/nst_array.h,v $
 *
 * $Log: nst_array.h,v $
 * Revision 1.6  1999/05/31 18:14:59  helge
 * Added inob-field (inob=interface-object) in *unitptr struct to allow some
 * Neo-related extensions. Other changes mainly removal of files from standard
 * libnst.a into dynamic folders (moved into foldersrc, cf. files added there)
 *
 * Revision 1.5  1999/02/23 09:07:59  helge
 * major debugging round for array_of-unit. Should now work.
 *
 * Revision 1.4  1997/12/21 15:50:43  helge
 * minor adjustments
 *
 * Revision 1.3  1997/04/02 14:07:50  helge
 * most man pages now in source code; some corrections;
 * for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:54:13  jan
 * Dependency cleanup.
 *
 *
 *****************************************************************************/

#ifndef __NST_ARRAY_H
#define __NST_ARRAY_H

#define NST_UPDATE_ARRAY -1234567 

typedef struct var_array_of_{ /* local var of unit array_of: */
   unitptr *puArrayEl;
   unitptr *puAdr;    /* only used in NST-variant */
   unitptr uOperand;  /* model for array els, NULL before instantiation */
   int isInitialized;
   int iNumDim;
   int iNumArrayEls;
   int *piDim;        /* ptr to iNumDim array limits */
   int *piIndex;      /* ptr to iNumDim current index values */
   int iSelected;     /* index of currently selected array el */
   int iOrigOperand;  /* index of the array el that represents the
                         original operand. */
   unitptr first_subunit,last_subunit;
} var_array_of_t;

extern unitptr find_operand_for_array_of(int,char*,unitptr);
extern unitptr mk_void_copy_of(unitptr, unitptr);
extern void copy_input_values(unitptr,unitptr);
extern int nst_is_array_unit(unitptr);
extern int nst_dim_of_array_unit(unitptr);
extern void nst_set_array_index(int,var_array_of_t*);
extern int *nst_current_array_index(unitptr);

extern unitptr array_of(
   int iNumDim,     /* nr of array dimensions */
   int *piDim,      /* limits for the .iNumDim array dimensions */
   unitptr *puArray, /* initializer array for array els */
   unitptr uHost    /* host unit */
);


#endif
