/***********************************************************************

  include file nst_cjgr.h: conjugate gradient minimization

  Copyright Helge Ritter, 1995 

 * $Source: /vol/ni/src/cvsroot/nst5/foldersrc/nst_cjgr.h,v $
 * $Log: nst_cjgr.h,v $
 * Revision 1.1  1999/05/31 17:43:07  helge
 * V7.0: math, cjgr and fft now as dynamic folder math.so
 *
 * Revision 1.3  1997/04/02 14:08:36  helge
 * most man pages now in source code; some corrections;
 * for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:54:32  jan
 * Dependency cleanup.
 *
 * Revision 1.3  1997/01/20 13:46:53  helge
 * various minor changes.
 *
 * Revision 1.2  1996/08/07  14:22:15  helge
 * New NST-Version 4.8 / Neo-Version 2.8  accumulating major changes
 *

***********************************************************************/
#ifndef __NST_CJGR_H
#define __NST_CJGR_H

extern unitptr conjugate_gradient(
   int iNumOperands,    /* nr of operands to include in evalutation call */
   int iDim,            /* nr of parameters for minimization */
   float *pfSearchDir,  /* initial search directions [may be NULL] */
   float (*pFunc)(int,float*), /* function to minimize (only used,
                                  if iNumOperands=0). May be NULL,
                                  if .iNumOperands>0. */
   char *pcOpt,         /* option string */
   unitptr uHost        /* host unit */
);



#endif
