/*****************************************************************************
 *
 * nst_iso.h  -  external definitions for nst_iso.c
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source: /vol/ni/src/cvsroot/nst5/nstsrc/nst_iso.h,v $
 *
 * $Log: nst_iso.h,v $
 * Revision 1.2  2000/01/10 18:12:50  helge
 * added declaration
 *
 * Revision 1.1  1997/08/25 10:55:01  jan
 * External definitions cleanup.
 *
 *
 *****************************************************************************/

#ifndef __NST_ISO_H
#define __NST_ISO_H

#include "nst_aux5.h"

extern void nst_move2(float,float);
extern void nst_draw2(float,float);

extern int exec_nst_iso(unitptr);
extern int adapt_nst_iso(unitptr);
extern int ctrl_nst_iso(int,unitptr);
extern int load_nst_iso(FILE*,unitptr);
extern int save_nst_iso(FILE*,unitptr);
extern int remove_nst_iso(unitptr);

typedef struct var_nst_iso_{ /* local var of unit nst_iso: */
  int iDx,iDy,iDz;
  NstInt_t iLevel;
  float fDx,fDy,fDz,fCtl;
  float afColorScale[3];
  float *pfVertex;
  char cColorOption;
  int  iRemoveBackfacingPolygons;
  int  iOperands;
  nst_winfo_t *pWinfo;
  void (*pGLRenderer)(char,float*,float*,unitptr);
} var_nst_iso_t;

extern void operate_isosurface(var_nst_iso_t*, unitptr u);

extern unitptr iso_surface(int, int, int, int, char*, void(*pGLRenderer)(char,float*,float*,unitptr), unitptr);

#endif
