/*****************************************************************************
 *
 * nst_solid2.h  -  header file for NST-unit general_cone
 *
 * Note: main() contains testing code and is conditionally compiled
 *       when DEBUG_RENDER_CONE is defined.
 *
 * Copyright Helge Ritter, 1992
 *
 * $Source: /vol/ni/src/cvsroot/nst5/foldersrc/nst_solid2.h,v $
 *
 * $Log: nst_solid2.h,v $
 * Revision 1.2  1997/10/22 15:59:58  helge
 * added new camera_unit for freely controlled viewing of 3d scenes
 *
 * Revision 1.1  1997/08/25 11:06:16  jan
 * Various bugfixes.
 *
 *
 *****************************************************************************/

#ifndef __NST_SOLID2_H
#define __NST_SOLID2_H

extern unitptr camera_unit(int, char*, char*, unitptr);

extern int render_gencone(int,int,char*,float*,
          float*,float*,float*,float*,float*);
extern void mk_elliptical_basepolygon(int,float,float,unitptr,int,float*);
extern void mk_rectangular_basepolygon(float,float,unitptr,int,float*);

extern int exec_general_cone(unitptr);
extern int adapt_general_cone(unitptr);
extern int ctrl_general_cone(int,unitptr);
extern int load_general_cone(FILE*,unitptr);
extern int save_general_cone(FILE*,unitptr);
extern int remove_general_cone(unitptr);

#define HAS_HEIGHT_VEC  1UL
#define HAS_PATH_VEC    2UL
#define HAS_TWIST_VEC   4UL
#define HAS_SCALE_VEC   8UL
#define CIRCLE_BASE     16UL
#define POLYGON_BASE    32UL
#define RECTANGLE_BASE  64UL
#define TOP_FACE       128UL
#define BOTTOM_FACE    256UL
#define CLEAR_BASE  (CIRCLE_BASE|POLYGON_BASE|RECTANGLE_BASE)

typedef struct var_general_cone_{ /* local var of unit general_cone: */
  unsigned long iFlags;
  int iSlices,iBasePnts;
  int iCircleEdges;
  float *pfPath;
  float *pfTwist;
  float *pfScale;
  float *pfBase;
} var_general_cone_t;

extern unitptr general_cone(int,  int, char*, unitptr);

#endif
